Index: branches/ScopedBasicAlgorithm/HeuristicLab 3.3.sln
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab 3.3.sln	(revision 14419)
+++ branches/ScopedBasicAlgorithm/HeuristicLab 3.3.sln	(revision 14420)
@@ -2,5 +2,5 @@
 Microsoft Visual Studio Solution File, Format Version 12.00
 # Visual Studio 14
-VisualStudioVersion = 14.0.23107.0
+VisualStudioVersion = 14.0.25420.1
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{96396439-A764-4022-A8D2-BE021449B8D1}"
@@ -32,4 +32,5 @@
 		{CB3D0A1E-1BE8-476B-A53C-2B189E30064F} = {CB3D0A1E-1BE8-476B-A53C-2B189E30064F}
 		{D34A7620-3E23-40D9-8647-637BE901F271} = {D34A7620-3E23-40D9-8647-637BE901F271}
+		{9D274421-6332-4FBC-AAE4-467ACE27C368} = {9D274421-6332-4FBC-AAE4-467ACE27C368}
 		{E0B45023-CB84-48A1-A1B7-8295B64B7BAD} = {E0B45023-CB84-48A1-A1B7-8295B64B7BAD}
 		{C633FB23-BAE6-448E-BF5D-E1F9A839B5ED} = {C633FB23-BAE6-448E-BF5D-E1F9A839B5ED}
@@ -449,4 +450,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.BinPacking-3.3", "HeuristicLab.Problems.BinPacking\3.3\HeuristicLab.Problems.BinPacking-3.3.csproj", "{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.MemPR-3.3", "HeuristicLab.Algorithms.MemPR\3.3\HeuristicLab.Algorithms.MemPR-3.3.csproj", "{9D274421-6332-4FBC-AAE4-467ACE27C368}"
 EndProject
 Global
@@ -2188,4 +2191,16 @@
 		{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}.Release|x86.ActiveCfg = Release|x86
 		{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}.Release|x86.Build.0 = Release|x86
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|x64.ActiveCfg = Debug|x64
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|x64.Build.0 = Debug|x64
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|x86.ActiveCfg = Debug|x86
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Debug|x86.Build.0 = Debug|x86
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|Any CPU.Build.0 = Release|Any CPU
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|x64.ActiveCfg = Release|x64
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|x64.Build.0 = Release|x64
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|x86.ActiveCfg = Release|x86
+		{9D274421-6332-4FBC-AAE4-467ACE27C368}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPR.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPR.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPR.cs	(revision 14420)
@@ -0,0 +1,263 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.LocalSearch;
+using HeuristicLab.Optimization.SolutionModel;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Algorithms.MemPR.Binary {
+  [Item("MemPR (binary)", "MemPR implementation for binary vectors.")]
+  [StorableClass]
+  [Creatable(CreatableAttribute.Categories.PopulationBasedAlgorithms, Priority = 999)]
+  public class BinaryMemPR : MemPRAlgorithm<BinaryVector, BinaryMemPRContext, BinarySingleSolutionMemPRContext> {
+    private const double UncommonBitSubsetMutationProbabilityMagicConst = 0.05;
+    
+    [StorableConstructor]
+    protected BinaryMemPR(bool deserializing) : base(deserializing) { }
+    protected BinaryMemPR(BinaryMemPR original, Cloner cloner) : base(original, cloner) { }
+    public BinaryMemPR() {
+      foreach (var trainer in ApplicationManager.Manager.GetInstances<IBinarySolutionModelTrainer<BinaryMemPRContext>>())
+        SolutionModelTrainerParameter.ValidValues.Add(trainer);
+      
+      foreach (var localSearch in ApplicationManager.Manager.GetInstances<IBinaryLocalSearch<BinarySingleSolutionMemPRContext>>()) {
+        // only use local search operators that can deal with a restricted solution space
+        var lsType = localSearch.GetType();
+        var genTypeDef = lsType.GetGenericTypeDefinition();
+        // TODO: By convention, context type must be put last
+        // TODO: Fails with non-generic types
+        if (genTypeDef.GetGenericArguments().Last().GetGenericParameterConstraints().Any(x => typeof(IBinarySolutionSubspaceContext).IsAssignableFrom(x))) {
+          localSearch.EvaluateFunc = EvaluateFunc;
+          LocalSearchParameter.ValidValues.Add(localSearch);
+        }
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BinaryMemPR(this, cloner);
+    }
+
+    protected double EvaluateFunc(BinaryVector solution) {
+      var scope = ToScope(solution);
+      Evaluate(scope, CancellationToken.None);
+      return scope.Fitness;
+    }
+
+    protected override bool Eq(ISingleObjectiveSolutionScope<BinaryVector> a, ISingleObjectiveSolutionScope<BinaryVector> b) {
+      var len = a.Solution.Length;
+      var acode = a.Solution;
+      var bcode = b.Solution;
+      for (var i = 0; i < len; i++)
+        if (acode[i] != bcode[i]) return false;
+      return true;
+    }
+
+    protected override double Dist(ISingleObjectiveSolutionScope<BinaryVector> a, ISingleObjectiveSolutionScope<BinaryVector> b) {
+      var len = a.Solution.Length;
+      var acode = a.Solution;
+      var bcode = b.Solution;
+      var hamming = 0;
+      for (var i = 0; i < len; i++)
+        if (acode[i] != bcode[i]) hamming++;
+      return hamming / (double)len;
+    }
+
+    protected override ISingleObjectiveSolutionScope<BinaryVector> ToScope(BinaryVector code, double fitness = double.NaN) {
+      var creator = Problem.SolutionCreator as IBinaryVectorCreator;
+      if (creator == null) throw new InvalidOperationException("Can only solve binary encoded problems with MemPR (binary)");
+      return new SingleObjectiveSolutionScope<BinaryVector>(code, creator.BinaryVectorParameter.ActualName, fitness, Problem.Evaluator.QualityParameter.ActualName) {
+        Parent = Context.Scope
+      };
+    }
+
+    protected override ISolutionSubspace CalculateSubspace(IEnumerable<BinaryVector> solutions, bool inverse = false) {
+      var pop = solutions.ToList();
+      var N = pop[0].Length;
+      var subspace = new bool[N];
+      for (var i = 0; i < N; i++) {
+        var val = pop[0][i];
+        if (inverse) subspace[i] = true;
+        for (var p = 1; p < pop.Count; p++) {
+          if (pop[p][i] != val) subspace[i] = !inverse;
+        }
+      }
+      return new BinarySolutionSubspace(subspace);
+    }
+
+    protected override ISingleObjectiveSolutionScope<BinaryVector> Create(CancellationToken token) {
+      var child = ToScope(null);
+      RunOperator(Problem.SolutionCreator, child, token);
+      return child;
+    }
+
+    protected override void TabuWalk(ISingleObjectiveSolutionScope<BinaryVector> scope, int steps, CancellationToken token, ISolutionSubspace subspace = null) {
+      var subset = subspace != null ? ((BinarySolutionSubspace)subspace).Subspace : null;
+      if (double.IsNaN(scope.Fitness)) Evaluate(scope, token);
+      SingleObjectiveSolutionScope<BinaryVector> bestOfTheWalk = null;
+      var currentScope = (SingleObjectiveSolutionScope<BinaryVector>)scope.Clone();
+      var current = currentScope.Solution;
+      var N = current.Length;
+      var tabu = new Tuple<double, double>[N];
+      for (var i = 0; i < N; i++) tabu[i] = Tuple.Create(current[i] ? double.NaN : currentScope.Fitness, !current[i] ? double.NaN : currentScope.Fitness);
+      var subN = subset != null ? subset.Count(x => x) : N;
+      if (subN == 0) return;
+      var order = Enumerable.Range(0, N).Where(x => subset == null || subset[x]).Shuffle(Context.Random).ToArray();
+
+      for (var iter = 0; iter < steps; iter++) {
+        var allTabu = true;
+        var bestOfTheRestF = double.NaN;
+        int bestOfTheRest = -1;
+        var improved = false;
+
+        for (var i = 0; i < subN; i++) {
+          var idx = order[i];
+          var before = currentScope.Fitness;
+          current[idx] = !current[idx];
+          Evaluate(currentScope, token);
+          var after = currentScope.Fitness;
+
+          if (IsBetter(after, before) && (bestOfTheWalk == null || IsBetter(after, bestOfTheWalk.Fitness))) {
+            bestOfTheWalk = (SingleObjectiveSolutionScope<BinaryVector>)currentScope.Clone();
+          }
+
+          var qualityToBeat = current[idx] ? tabu[idx].Item2 : tabu[idx].Item1;
+          var isTabu = !IsBetter(after, qualityToBeat);
+          if (!isTabu) allTabu = false;
+
+          if (IsBetter(after, before) && !isTabu) {
+            improved = true;
+            tabu[idx] = current[idx] ? Tuple.Create(after, tabu[idx].Item2) : Tuple.Create(tabu[idx].Item1, after);
+          } else { // undo the move
+            if (!isTabu && IsBetter(after, bestOfTheRestF)) {
+              bestOfTheRest = idx;
+              bestOfTheRestF = after;
+            }
+            current[idx] = !current[idx];
+            currentScope.Fitness = before;
+          }
+        }
+        if (!allTabu && !improved) {
+          var better = currentScope.Fitness;
+          current[bestOfTheRest] = !current[bestOfTheRest];
+          tabu[bestOfTheRest] = current[bestOfTheRest] ? Tuple.Create(better, tabu[bestOfTheRest].Item2) : Tuple.Create(tabu[bestOfTheRest].Item1, better);
+          currentScope.Fitness = bestOfTheRestF;
+        } else if (allTabu) break;
+      }
+
+      scope.Adopt(bestOfTheWalk ?? currentScope);
+    }
+
+    protected override ISingleObjectiveSolutionScope<BinaryVector> Cross(ISingleObjectiveSolutionScope<BinaryVector> p1, ISingleObjectiveSolutionScope<BinaryVector> p2, CancellationToken token) {
+      var offspring = (ISingleObjectiveSolutionScope<BinaryVector>)p1.Clone();
+      offspring.Fitness = double.NaN;
+      var code = offspring.Solution;
+      var p2Code = p2.Solution;
+      var bp = 0;
+      var lastbp = 0;
+      for (var i = 0; i < code.Length; i++) {
+        if (code[i] == p2Code[i]) continue; // common bit
+        if (bp % 2 == 1) {
+          code[i] = p2Code[i];
+        }
+        if (Context.Random.Next(code.Length) < i - lastbp) {
+          bp = (bp + 1) % 2;
+          lastbp = i;
+        }
+      }
+      return offspring;
+    }
+
+    protected override void Mutate(ISingleObjectiveSolutionScope<BinaryVector> offspring, CancellationToken token, ISolutionSubspace subspace = null) {
+      var subset = subspace != null ? ((BinarySolutionSubspace)subspace).Subspace : null;
+      offspring.Fitness = double.NaN;
+      var code = offspring.Solution;
+      for (var i = 0; i < code.Length; i++) {
+        if (subset != null && subset[i]) continue;
+        if (Context.Random.NextDouble() < UncommonBitSubsetMutationProbabilityMagicConst) {
+          code[i] = !code[i];
+          if (subset != null) subset[i] = true;
+        }
+      }
+    }
+
+    protected override ISingleObjectiveSolutionScope<BinaryVector> Relink(ISingleObjectiveSolutionScope<BinaryVector> a, ISingleObjectiveSolutionScope<BinaryVector> b, CancellationToken token) {
+      if (double.IsNaN(a.Fitness)) Evaluate(a, token);
+      if (double.IsNaN(b.Fitness)) Evaluate(b, token);
+      if (Context.Random.NextDouble() < 0.5)
+        return IsBetter(a, b) ? Relink(a, b, token, false) : Relink(b, a, token, true);
+      else return IsBetter(a, b) ? Relink(b, a, token, true) : Relink(a, b, token, false);
+    }
+
+    protected virtual ISingleObjectiveSolutionScope<BinaryVector> Relink(ISingleObjectiveSolutionScope<BinaryVector> betterScope, ISingleObjectiveSolutionScope<BinaryVector> worseScope, CancellationToken token, bool fromWorseToBetter) {
+      var childScope = (ISingleObjectiveSolutionScope<BinaryVector>)(fromWorseToBetter ? worseScope : betterScope).Clone();
+      var child = childScope.Solution;
+      var better = betterScope.Solution;
+      var worse = worseScope.Solution;
+      ISingleObjectiveSolutionScope<BinaryVector> best = null;
+      var cF = fromWorseToBetter ? worseScope.Fitness : betterScope.Fitness;
+      var bF = double.NaN;
+      var order = Enumerable.Range(0, better.Length).Shuffle(Context.Random).ToArray();
+      while (true) {
+        var bestS = double.NaN;
+        var bestIdx = -1;
+        for (var i = 0; i < child.Length; i++) {
+          var idx = order[i];
+          // either move from worse to better or move from better away from worse
+          if (fromWorseToBetter && child[idx] == better[idx] ||
+            !fromWorseToBetter && child[idx] != worse[idx]) continue;
+          child[idx] = !child[idx]; // move
+          Evaluate(childScope, token);
+          var s = childScope.Fitness;
+          childScope.Fitness = cF;
+          child[idx] = !child[idx]; // undo move
+          if (IsBetter(s, cF)) {
+            bestS = s;
+            bestIdx = idx;
+            break; // first-improvement
+          }
+          if (double.IsNaN(bestS) || IsBetter(s, bestS)) {
+            // least-degrading
+            bestS = s;
+            bestIdx = idx;
+          }
+        }
+        if (bestIdx < 0) break;
+        child[bestIdx] = !child[bestIdx];
+        cF = bestS;
+        childScope.Fitness = cF;
+        if (IsBetter(cF, bF)) {
+          bF = cF;
+          best = (ISingleObjectiveSolutionScope<BinaryVector>)childScope.Clone();
+        }
+      }
+      return best ?? childScope;
+    }
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPRContext.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPRContext.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinaryMemPRContext.cs	(revision 14420)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Binary {
+  [Item("BinaryMemPRContext", "MemPR context for binary encoded problems.")]
+  [StorableClass]
+  public sealed class BinaryMemPRContext : MemPRContext<BinaryVector, BinaryMemPRContext, BinarySingleSolutionMemPRContext> {
+
+    [StorableConstructor]
+    private BinaryMemPRContext(bool deserializing) : base(deserializing) { }
+    private BinaryMemPRContext(BinaryMemPRContext original, Cloner cloner)
+      : base(original, cloner) { }
+    public BinaryMemPRContext() : base("BinaryMemPRContext") { }
+    public BinaryMemPRContext(string name) : base(name) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BinaryMemPRContext(this, cloner);
+    }
+
+    public override BinarySingleSolutionMemPRContext CreateSingleSolutionContext(ISingleObjectiveSolutionScope<BinaryVector> solution) {
+      return new BinarySingleSolutionMemPRContext(this, solution);
+    }
+  }
+
+  [Item("BinarySingleSolutionMemPRContext", "Single solution MemPR context for binary encoded problems.")]
+  [StorableClass]
+  public sealed class BinarySingleSolutionMemPRContext : SingleSolutionMemPRContext<BinaryVector, BinaryMemPRContext, BinarySingleSolutionMemPRContext>, IBinarySolutionSubspaceContext {
+
+    [Storable]
+    private IValueParameter<BinarySolutionSubspace> subspace;
+    public BinarySolutionSubspace Subspace {
+      get { return subspace.Value; }
+    }
+    ISolutionSubspace ISolutionSubspaceContext.Subspace {
+      get { return Subspace; }
+    }
+
+    [StorableConstructor]
+    private BinarySingleSolutionMemPRContext(bool deserializing) : base(deserializing) { }
+    private BinarySingleSolutionMemPRContext(BinarySingleSolutionMemPRContext original, Cloner cloner)
+      : base(original, cloner) {
+
+    }
+    public BinarySingleSolutionMemPRContext(BinaryMemPRContext baseContext, ISingleObjectiveSolutionScope<BinaryVector> solution)
+      : base(baseContext, solution) {
+
+      Parameters.Add(subspace = new ValueParameter<BinarySolutionSubspace>("Subspace", new BinarySolutionSubspace(null)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BinarySingleSolutionMemPRContext(this, cloner);
+    }
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinarySolutionSubspace.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinarySolutionSubspace.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/BinarySolutionSubspace.cs	(revision 14420)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Binary {
+  [Item("Solution subspace (binary)", "")]
+  [StorableClass]
+  public sealed class BinarySolutionSubspace : Item, ISolutionSubspace {
+
+    [Storable]
+    private bool[] subspace;
+    public bool[] Subspace { get { return subspace; } }
+
+    [StorableConstructor]
+    private BinarySolutionSubspace(bool deserializing) : base(deserializing) { }
+    private BinarySolutionSubspace(BinarySolutionSubspace original, Cloner cloner)
+      : base(original, cloner) {
+      subspace = (bool[])original.subspace.Clone();
+    }
+    public BinarySolutionSubspace(bool[] subspace) {
+      this.subspace = subspace;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BinarySolutionSubspace(this, cloner);
+    }
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflip.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflip.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflip.cs	(revision 14420)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.LocalSearch;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Binary.LocalSearch {
+  [Item("Exhaustive Bitflip Local Search (binary)", "")]
+  [StorableClass]
+  public class ExhaustiveBitflip<TContext> : ExhaustiveBitflipOperator, IBinaryLocalSearch<TContext> 
+      where TContext : ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext, IMaximizationContext,
+                       IEvaluatedSolutionsContext, IIterationsManipulationContext {
+    
+    [StorableConstructor]
+    protected ExhaustiveBitflip(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveBitflip(ExhaustiveBitflip<TContext> original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveBitflip() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveBitflip<TContext>(this, cloner);
+    }
+
+    public void Optimize(TContext context) {
+      var quality = context.Solution.Fitness;
+      try {
+        var result = Heuristic.ExhaustiveBitFlipSearch(context.Random, context.Solution.Solution, ref quality,
+          context.Maximization, EvaluateFunc, CancellationToken);
+        context.EvaluatedSolutions = result.Item1;
+        context.Iterations = result.Item2;
+      } finally {
+        context.Solution.Fitness = quality;
+      }
+    }
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipOperator.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipOperator.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipOperator.cs	(revision 14420)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.LocalSearch;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Binary.LocalSearch {
+  [Item("Exhaustive Bitflip Local Search Operator (binary)", "")]
+  [StorableClass]
+  public class ExhaustiveBitflipOperator : SingleSuccessorOperator, ILocalSearch<BinaryVector>, ISingleObjectiveOperator, IStochasticOperator {
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    
+    public ILookupParameter<BinaryVector> SolutionParameter {
+      get { return (ILookupParameter<BinaryVector>)Parameters["Solution"]; }
+    }
+
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+
+    public ILookupParameter<BoolArray> SubspaceParameter {
+      get { return (ILookupParameter<BoolArray>)Parameters["Subspace"]; }
+    }
+
+    public Func<BinaryVector, double> EvaluateFunc { get; set; }
+
+    [StorableConstructor]
+    protected ExhaustiveBitflipOperator(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveBitflipOperator(ExhaustiveBitflipOperator original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveBitflipOperator() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator to use."));
+      Parameters.Add(new LookupParameter<BinaryVector>("Solution", "The solution that is to be optimized"));
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "Whether the solution's quality should be maximized or minimized."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the solution."));
+      Parameters.Add(new LookupParameter<BoolArray>("Subspace", "Whether the local search should be confined to a sub-space of the solution space (indicated by true in this vector)."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveBitflipOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      var quality = QualityParameter.ActualValue.Value;
+      var subspace = SubspaceParameter.ActualValue != null ? SubspaceParameter.ActualValue.ToArray() : null;
+      try {
+        Heuristic.ExhaustiveBitFlipSearch(RandomParameter.ActualValue,
+          SolutionParameter.ActualValue, ref quality, MaximizationParameter.ActualValue.Value,
+          EvaluateFunc, CancellationToken, subspace);
+      } finally {
+        QualityParameter.ActualValue.Value = quality;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipSubspace.cs
===================================================================
--- branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipSubspace.cs	(revision 14420)
+++ branches/ScopedBasicAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Binary/LocalSearch/ExhaustiveBitflipSubspace.cs	(revision 14420)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.LocalSearch;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.Binary.LocalSearch {
+  [Item("Exhaustive Bitflip Local (Subspace) Search (binary)", "")]
+  [StorableClass]
+  public class ExhaustiveBitflipSubspace<TContext> : ExhaustiveBitflipOperator, IBinaryLocalSearch<TContext>
+      where TContext : ISingleObjectiveSolutionContext<BinaryVector>, IStochasticContext, IMaximizationContext,
+                       IEvaluatedSolutionsContext, IIterationsManipulationContext, IBinarySolutionSubspaceContext {
+
+    [StorableConstructor]
+    protected ExhaustiveBitflipSubspace(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveBitflipSubspace(ExhaustiveBitflipSubspace<TContext> original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveBitflipSubspace() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveBitflipSubspace<TContext>(this, cloner);
+    }
+
+    public void Optimize(TContext context) {
+      var quality = context.Solution.Fitness;
+      try {
+        var result = Heuristic.ExhaustiveBitFlipSearch(context.Random, context.Solution.Solution, ref quality,
+          context.Maximization, EvaluateFunc, CancellationToken, context.Subspace != null ? context.Subspace.Subspace : null);
+        context.EvaluatedSolutions = result.Item1;
+        context.Iterations = result.Item2;
+      } finally {
+        context.Solution.Fitness = quality;
+      }
+    }
+  }
+}
